/* Tabela RELACMAPANF: Notas relacioandas ao Mapa de Apurao geradas na Preparao de Pagamento */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela RELACMAPANF */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Relacionamento de Notas geradas na
             Preparao de Pagamento ao Mapa de Apurao, utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIS_RELACMAPANF
AFTER DELETE OR INSERT OR UPDATE
ON RELACMAPANF FOR EACH ROW
DECLARE
   V_DSREMOTEADDR VARCHAR2(50);
   V_DSREMOTEHOST VARCHAR2(50);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(50);
   V_DSREMOTEOPER VARCHAR2(12);
   V_NMOPERADOR   VARCHAR2(100);
   V_TIPO         VARCHAR2(1);
   V_DESC         VARCHAR2(1000);
   V_CDFILLOGOPER VARCHAR2(4);
   V_ITPESQ       VARCHAR2(40);
   V_DTOPER       DATE;
   V_STATUS       VARCHAR2(10);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';

   IF DELETING THEN
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || ' CdFilialNf=' || :OLD.CDFILIAL;
      END IF;
      IF :OLD.NRLANCTONF IS NOT NULL THEN
         V_DESC := V_DESC || ' NrLancamento=' || :OLD.NRLANCTONF;
      END IF;
      IF :OLD.DTVENCMAPANF IS NOT NULL THEN
         V_DESC := V_DESC || ' DataVenc=' || :OLD.DTVENCMAPANF;
      END IF;
      V_TIPO         := '3';
      V_ITPESQ       := :OLD.NRSEQUMAPAPU;
   ELSE
      IF UPDATING THEN
         IF NVL(:NEW.CDFILIAL, '!')   <> NVL(:OLD.CDFILIAL, '!')     OR
            NVL(:NEW.NRLANCTONF, '!') <> NVL(:OLD.NRLANCTONF, '!')   OR
            NVL(:NEW.DTVENCMAPANF,TO_DATE('01/01/1900', 'DD/MM/YYYY')) <> NVL(:OLD.DTVENCMAPANF,TO_DATE('01/01/1900', 'DD/MM/YYYY')) THEN
            V_TIPO         := '2';
            V_ITPESQ       := :OLD.NRSEQUMAPAPU;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.NRSEQUMAPAPU;
      END IF;

      IF NVL(:NEW.CDFILIAL, '!') <> NVL(:OLD.CDFILIAL, '!') THEN
         V_DESC := V_DESC || ' CdFilialNf=' || :NEW.CDFILIAL;
      END IF;
      IF NVL(:NEW.NRLANCTONF, '!') <> NVL(:OLD.NRLANCTONF, '!') THEN
         V_DESC := V_DESC || ' NrLancamento=' || :NEW.NRLANCTONF;
      END IF;
      IF NVL(:NEW.DTVENCMAPANF,TO_DATE('01/01/1900', 'DD/MM/YYYY')) <> NVL(:OLD.DTVENCMAPANF,TO_DATE('01/01/1900', 'DD/MM/YYYY')) THEN
         V_DESC := V_DESC || ' DataVenc=' || :NEW.DTVENCMAPANF;
      END IF;
   END IF;

   IF  V_TIPO <> '0' THEN
       NMUSUARIO(V_NMOPERADOR);
       WEBTUNNING(V_DSREMOTEADDR,
                  V_DSREMOTEHOST,
                  V_DSSERVERRDM,
                  V_DSSERVMETHOD,
                  V_DSREMOTEOPER);

       IF NOT V_DESC IS NULL THEN
         IF NOT V_NMOPERADOR IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,     DTOPERACAO,   NMRESPOPER,   IDTIPOOPER,  CDPESQITEM,  DSOPERACAO,
                CDFILLOGOPER, DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER,CDORESPOPER)
            VALUES
               ('RELACMAPANF',  V_DTOPER,      V_NMOPERADOR,   V_TIPO,         V_ITPESQ,       SUBSTR(V_DESC,1,400),
                V_CDFILLOGOPER, V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
       END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_RELACMAPANF','6.06.000'); END;
/
