var Fis_Sef2_Controller = function(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil){
    
    var self = this;
    
    self.addAgendamento = function(widget){
        widget.newRow(); 
        widget.getField('DTREFINI').isVisible = true;
    };
    
    self.cancelAgendamento = function(args){
        General.backOrCancel(args); 
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };
    
    self.editAgendamento = function(widget){
        General.edit(widget); 
        this.periodicidadeOnChange(widget);
    };
    
    self.saveAgendamento = function(widget){
        if (widget.isValid()) {
		    var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));
            
		    if(d1.getTime() > d2.getTime()){
                if(((widget.currentRow.CDINSCESTA == '') || (widget.currentRow.CDINSCESTA == null)) && (widget.currentRow.CDEMPRESA)){
                    widget.currentRow.CDINSCESTA = "T";
                }
                
                widget.currentRow.NRORG = getLocalVar('NRORG');
                
                General.callRestEngine('fis_acessorias#/saveAgendamentoSef2','Row', widget.currentRow).then(
                    function(success){
                        General.changeWidgetAcessibility(widget.widgets, true);
                        ScreenService.showMessage('Agendado com sucesso.');
                        ScreenService.goBack();
                        widget.getField('DTREFINI').isVisible = true;
                        widget.reload();
                    },
                    function(error){
                        ScreenService.showMessage(error.data.error);
                    }
                );
		    } else {
		        ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
		    }
            
        } else {
			// @todo create messages class
			ScreenService.showMessage("Preencha todos os campos corretamente!");
		}
    };
    
    self.downloadArquivoAgendado = function(spedWidget) {
        var downloadRoute;
        var fileName;
        
        if(spedWidget.hasCheckedRows()){
            var rows = spedWidget.getCheckedRows();
            rows.forEach(function(row){
                downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;
                
                window.open(downloadRoute + fileName);
            });
        } 
        else {
            var row = spedWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;
            
            window.open(downloadRoute + fileName);
        }
        
    };
    
    self.deleteAgendamento = function(widget){
        widget.currentRow.NRORG = getLocalVar('NRORG');
        
        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
        	General.callRestEngine('fis_acessorias#/deleteAgendamentoSef2','Row', widget.currentRow).then(
                function(success){
                    ScreenService.showMessage('Deletado com sucesso.');
                    ScreenService.goBack();
                    widget.reload();
                },
                function(error){
                    ScreenService.showMessage(error.data.error);
                }
            );
        });
    };

    self.periodicidadeOnChange = function(widget){
        if(widget.currentRow.IDPERIAGEN == 0){
            widget.getField('DTREFINI').isVisible = true;
        }
        else if(widget.currentRow.IDPERIAGEN == 1){
            widget.getField('DTREFINI').isVisible = false;
            if((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != ""){
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        }
        else if(widget.currentRow.IDPERIAGEN == 2){
            widget.getField('DTREFINI').isVisible = false;
            if((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != ""){
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };
    
    /**
     * Função para a chamada de Exportação
     */
    self.exportarSef2 = function(sef2Widget){
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if(sef2Widget.isValid()){
            // Verifica se a parametrização não foi carregada e verificada
            if(!parametrizacaoWasLoaded(sef2Widget)){
                return;
            }
            var parametrosWidget = templateManager.container.getWidget('parametrosGeraisSef2');
            // Define propriedades na widget principal com valores dos fields
            // da tab de parametrização
            preenhcerPropriedadesWidgetPrincipal(sef2Widget, parametrosWidget);
            var row = sef2Widget.currentRow;
            var route = 'fis#/exportarSef2';
            var message = Messages_fiscal.EXPORTANDO_SEF_II;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    /**
     * Função auxiliar que verifica se a tab de parametrização foi aberta ao exportar,
     * através da propriedade 'empresasLoaded'.
     */ 
    var parametrizacaoWasLoaded = function(sef2Widget){
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdEmpresa = sef2Widget.currentRow.CDEMPRESA;
        parametrosWidget = templateManager.container.getWidget('parametrosGeraisSef2');
        // Verifica se a propriedade (CDEMPRESA) está setada para a empresa selecionada
        parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdEmpresa];
        
        // Verifica se a widget de parametrização não foi aberta antes de
        // clicar no botão de exportar
        if(!parametrizacaoWasLoaded){
            // Muda a propriedade para que a parametrização seja obrigatória
            parametrosWidget.parametersRequired = true;
            // Exibe mensagem indicando a obrigatoriedae da verificação dos parametros
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR).
            then(function(){
                // Abre a widget/tab de parâmetros
                openTabParametrosGerais(parametrosWidget);
            });
            // Retorna false, indicando que a parametrização não foi previamente aberta
            return false;
        }
        // Retorna true, caso a parametrização já tenha sido aberta
        return true;
    };
    /**
     * Função auxiliar que abre a tab de parâmetros pela primeira vez.
     */ 
    var openTabParametrosGerais = function(parametrosWidget){
        // Recarrega os dados (dataSource) parametrizados
        parametrosWidget.reload().then(function(){
            // Redesenha os dados carregados na tab
            parametrosWidget.redraw();
        });
        // Define a tab de parametricação como ativa
        parametrosWidget.activate();
    };
    /**
     * Função auxiliar que cria e preenche propriedades da widget principal,
     * com os valores das fields da tab de parâmetros
     */
    var preenhcerPropriedadesWidgetPrincipal = function(sef2Widget, parametrosWidget){
        sef2Widget.currentRow.STSUFRAMA = parametrosWidget.currentRow.STSUFRAMA;
        sef2Widget.currentRow.STARQUIVO = parametrosWidget.currentRow.STARQUIVO;
        sef2Widget.currentRow.STVERSAO = parametrosWidget.currentRow.STVERSAO;
        sef2Widget.currentRow.STFINALIDADE = parametrosWidget.currentRow.STFINALIDADE;
        sef2Widget.currentRow.STREGINV = parametrosWidget.currentRow.STREGINV;
        sef2Widget.currentRow.STOPISS = parametrosWidget.currentRow.STOPISS;
        sef2Widget.currentRow.STOPIPI = parametrosWidget.currentRow.STOPIPI;
    };
    /**
     * Função para salvar os parâmetros informados - ou caso eles já existam,
     * apenas os confirmam para a exportação
     */
    self.salvarParametrizacao = function(parametrosWidget){
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if(parametrosWidget.isValid()){
            var sef2Widget = templateManager.container.getWidget('Sef-ii');
            var stsuframa = parametrosWidget.currentRow.STSUFRAMA;
            // Valida se o campo Suframa tem apenas números
            if(isNaN(stsuframa)){
                // Se não, mensagem de alerta é lançada
                ScreenService.showMessage('O campo Suframa deve ser numérico');
                return;
            }
            preencherCamposAbstratosParaSalvar(parametrosWidget);
            parametrosWidget.saveRow()
            .then(function(){
                // Seta os parametros como verificados pelo usuário
                setParametersVerified(parametrosWidget);
                // Ativa a widget principal
                sef2Widget.activate();
                sef2Widget.currentWidget = sef2Widget;
                /**
                 * Verifica se a tela de parâmetros foi exibida devido a uma tentativa
                 * de exportação. Caso positivo, a exportação é efetuada
                 */
                if(parametrosWidget.parametersRequired){
                    self.exportarSef2(sef2Widget);
                    // Valida a propriedade para false, caso a tela de parametros seja
                    // novamente aberta. E assim não haverá exportação sempre ao sair
                    parametrosWidget.parametersRequired = false;
                }
            });
        }
    };
    
    var preencherCamposAbstratosParaSalvar = function(parametrosWidget){
        parametrosWidget.currentRow.CDCAMPO1=parametrosWidget.currentRow.STSUFRAMA;
        parametrosWidget.currentRow.CDCAMPO9=parametrosWidget.currentRow.STARQUIVO;
        parametrosWidget.currentRow.CDCAMPO2=parametrosWidget.currentRow.STVERSAO;
        parametrosWidget.currentRow.CDCAMPO3=parametrosWidget.currentRow.STFINALIDADE;
        parametrosWidget.currentRow.CDCAMPO4=parametrosWidget.currentRow.STREGINV;
        parametrosWidget.currentRow.CDCAMPO11=parametrosWidget.currentRow.STOPISS;
        parametrosWidget.currentRow.CDCAMPO7=parametrosWidget.currentRow.STOPIPI;
    };
    /**
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário
     */
    var setParametersVerified = function(parametrosWidget){
        var currentRow = parametrosWidget.currentRow;
        var sef2FiscalIsSelected = parametrosWidget.name == "parametrosGeraisSef2";
        if (sef2FiscalIsSelected) {
            var sef2Widget = templateManager.container.getWidget("Dac-Al");
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
            //sef2Widget.currentRow.REG1400 = (Array.isArray(currentRow.CDOBRIGARRAY) && currentRow.CDOBRIGARRAY.indexOf(4) !== -1);
        }
        else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    }; 
    /**
     * Função que é invocada após o carregamento do dataSource. Caso é 
     * retornado algo, adiciona à currentRow o primeiro indice de data[] - caso
     * contrário, é setada em forma de newRow;
     */ 
    self.setLoadedParameters = function(parametrosWidget){
        var sef2Widget = templateManager.container.getWidget("Sef-ii");
        if(parametrosWidget.dataSource.data.length > 0){
            // Seta a currentRow como sendo o primeiro indice do data[] retornado
            parametrosWidget.moveToFirst();
            // Redesenha na widget principal, os fields com os valores da nova 
            // currentRow
            parametrosWidget.redraw();
        }else{
            // Seta a widget em modo de novo dado, para inserir a parametrização
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = sef2Widget.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = sef2Widget.currentRow.NMEMPRESA;
    };
    /**
     * Função invocada ao sair da widget de parametros, que seta os mesmos como 
     * verificados
     */ 
    self.beforeExitParametrosGerais = function(parametrosWidget){
        // Seta a parametrização como verificada somente se a widget não estiver
        // em modo de inserção, mas sim de verificação
        if(!parametrosWidget.isNewRow()){
            setParametersVerified(parametrosWidget);
        }
    };
    /**
     * Função que é invocada ao alterar o field CDINSCESTA,
     * alterando a propriedade enable da tab de parâmetros
     */ 
    self.inscricaoOnChange = function(sef2Widget){
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisSef2');
        // Variável booleana que é setada como true, caso alguma inscrição seja 
        // selecionada
        var inscricaoIsSelect = !!sef2Widget.currentRow.CDINSCESTA;
        parametrosWidget.enabled = inscricaoIsSelect;
    };
};
Configuration(function(ContextRegister){
    ContextRegister.register("Fis_Sef2_Controller", Fis_Sef2_Controller);
});